﻿#region 2009, Anytao.com

// Release : 2008/11/02                            
// Author  : Anytao, http://www.anytao.com 
// Url     : http://www.cnblogs.com/anytao/archive/2009/01/20/anytao_silverlight_01_communication_handler.html

#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Browser;

namespace Anytao.SLScenario.AccessHandler
{
    public partial class Page : UserControl
    {
        private delegate void DispatcherInvoke(string param);

        public Page()
        {
            InitializeComponent();
        }

        private void btnGetByWebClient_Click(object sender, RoutedEventArgs e)
        {
            GetResultByWebClient(name.Text, pwd.Text);
        }

        private void GetResultByWebClient(string name, string pwd)
        {
            string absolutePath = HtmlPage.Document.DocumentUri.AbsoluteUri;
            string address = absolutePath.Substring(0, absolutePath.LastIndexOf('/'))
                + "/Handler/UserHandler.ashx?name=" + name + "&pwd=" + pwd;

            Uri uri = new Uri(address);

            WebClient client = new WebClient();
            client.DownloadStringCompleted += (sender, e) =>
                {
                    if (null == e.Error)
                    {
                        result.Text = e.Result;
                        //Call other service here to continue operation
                    }
                    else
                    {
                        MessageBox.Show(e.Error.Message);
                    }
                };
                
                //new DownloadStringCompletedEventHandler(client_DownloadStringCompleted);
            client.DownloadStringAsync(uri);
        }

        private void GetResultByWebClientUploadString(string name, string pwd)
        {
            string absolutePath = HtmlPage.Document.DocumentUri.AbsoluteUri;
            string address = absolutePath.Substring(0, absolutePath.LastIndexOf('/'))
                + "/Handler/UserHandler.ashx";

            Uri uri = new Uri(address);

            WebClient client = new WebClient();
            client.UploadStringCompleted += (sender, e) =>
            {
                if (null == e.Error)
                {
                    result.Text = e.Result;
                    //Call other service here to continue operation
                }
                else
                {
                    MessageBox.Show(e.Error.Message);
                }
            };

            //new DownloadStringCompletedEventHandler(client_DownloadStringCompleted);
            client.UploadStringAsync(uri, "name=" + name + "&pwd=" + pwd);
        }

        void client_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            if (null == e.Error)
            {
                result.Text = e.Result;

                //Call another WCF Service continuously

                //ServiceClient service = new ServiceClient();
                //SaveSeatRequest request = new SaveSeatRequest();
                //request.BookingItemId = new Guid(e.Result);
                //request.PickingSeats = GetSeats(PickContext.Current.PickingSeat);

                //service.SaveSeatsCompleted += new EventHandler<SaveSeatsCompletedEventArgs>(service_SaveSeatsCompleted);
                //service.SaveSeatsAsync(request.BookingItemId, request.ClientTag, request.PickingSeats);
            }
            else
            {
                MessageBox.Show(e.Error.Message);
            }
        }

        private void btnGetByWebRequest_Click(object sender, RoutedEventArgs e)
        {
            GetResultByWebRequest(name.Text, pwd.Text);
        }

        private void GetResultByWebRequest(string name, string pwd)
        {
            string absolutePath = HtmlPage.Document.DocumentUri.AbsoluteUri;
            string address = absolutePath.Substring(0, absolutePath.LastIndexOf('/'))
                + "/Handler/UserHandler.ashx?name=" + name + "&pwd=" + pwd;

            Uri uri = new Uri(address);
            WebRequest request = WebRequest.Create(uri);
            request.Method = "POST";
            request.ContentType = "application/x-www-form-urlencoded";
            //request.BeginGetRequestStream((AsyncCallback)RequestReady, request);
            request.BeginGetRequestStream(new AsyncCallback(RequestReady), request);
        }

        private void RequestReady(IAsyncResult ar)
        {
            WebRequest request = ar.AsyncState as WebRequest;
            using (System.IO.StreamWriter sw = new System.IO.StreamWriter(request.EndGetRequestStream(ar)))
            {
                sw.Write("Post data to server.");
            }

            //request.BeginGetResponse((AsyncCallback)ResponseHandler, request);
            request.BeginGetResponse(new AsyncCallback(ResponseReady), request);
        }

        private void ResponseReady(IAsyncResult ar)
        {
            WebRequest request = ar.AsyncState as WebRequest;
            using (WebResponse response = request.EndGetResponse(ar))
            {
                using (System.IO.Stream stream = response.GetResponseStream())
                {
                    using (System.IO.StreamReader reader = new System.IO.StreamReader(stream))
                    {
                        Dispatcher.BeginInvoke((DispatcherInvoke)BindAndNext, reader.ReadToEnd());
                    }
                }
            }
        }

        private void BindAndNext(string result)
        {
            if (!string.IsNullOrEmpty(result))
            {
                this.result.Text = result;

                //Call another WCF Service continuously
            }
            else
            {
                MessageBox.Show("Error");
            }
        }
    }
}
