﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Web;

namespace Anytao.SLScenario.Service
{
    // Release : 2009/02/12                            
    // Author  : Anytao, http://www.anytao.com 
    [ServiceContract(Namespace="http://api.anytao.com/rest/")]
    public interface IPostService
    {
        //Note: Import the System.ServiceModel.Web
        //for WebGetAttribute


        [OperationContract]
        [WebGet(UriTemplate = "/", ResponseFormat = WebMessageFormat.Xml)]
        List<User> GetAllUsers();

        [OperationContract]
        [WebGet(UriTemplate = "/{name}", ResponseFormat = WebMessageFormat.Xml)]
        List<Post> GetPostsByName(string name);

        [OperationContract]
        [WebGet(UriTemplate = "/{name}/{post}", ResponseFormat = WebMessageFormat.Json)]
        Post GetPostByID(string name, string post);

        [OperationContract]
        [WebGet(UriTemplate = "/{name}/{post}/{comment}", ResponseFormat = WebMessageFormat.Json)]
        Comment GetCommentByAuthor(string name, string post, string comment);

        [OperationContract]
        [WebInvoke(UriTemplate = "/{name}/{post}", Method = "POST")]
        Comment AddComment(string name, string post, Comment comment);
    }
}
