﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Anytao.SLScenario.Service
{
    public class PostService : IPostService
    {
        private List<User> users;

        public PostService()
        {
            users = new List<User>()
            {
                new User() 
                { 
                    ID = 1, 
                    Name = "Anytao", 
                    Age = 28, 
                    Desc = "Administator", 
                    Posts = new List<Post> 
                    {
                        new Post
                        {
                            ID=1, Content="111", Comments = new List<Comment>()
                            {
                                new Comment{ID=1, Author="XiaoWang", Desc="Good."}, 
                                new Comment{ID=2, Author="XiaoLi", Desc="Not good."},
                                new Comment{ID=3, Author="XiaoZhang", Desc="I like it."}
                            }
                        }, 
                        new Post
                        {
                            ID=2, Content="222", Comments = new List<Comment>()
                            {
                                new Comment{ID=4, Author="LaoWang", Desc="Give me code."}, 
                                new Comment{ID=5, Author="LaoLi", Desc="Thanks."}
                            }
                        }
                    } 
                },
                new User()
                {
                    ID = 2,
                    Name = "Zhang3",
                    Age = 30,
                    Desc = "TeamLeader",
                    Posts = new List<Post>
                    {
                        new Post
                        {
                            ID=3, Content="333", Comments = new List<Comment>()
                            {
                                new Comment{ID=6, Author="XiaoLi", Desc="Sofa."}, 
                                new Comment{ID=7, Author="LaoLi", Desc="Great job."}
                            }
                        },
                        new Post
                        {
                            ID=4, Content="444", Comments = new List<Comment>()
                            {
                                new Comment{ID=8, Author="Coder", Desc="Expect next version."}
                            }
                        },
                        new Post
                        {
                            ID=5, Content="555", Comments = new List<Comment>()
                            {
                                new Comment{ID=9, Author="Oh", Desc="Thinking.."},
                                new Comment{ID=10, Author="Oh", Desc="I love .NET."},
                                new Comment{ID=11, Author="Coder", Desc="Thank you."}
                            }
                        }
                    }
                }
            };
        }

        public List<User> GetAllUsers()
        {
            return users;
        }

        public List<Post> GetPostsByName(string name)
        {
            User user = (from u in users
                         where u.Name == name
                         select u).Single();

            return user.Posts;
        }

        public Post GetPostByID(string name, string post)
        {
            throw new NotImplementedException();
        }

        public Comment GetCommentByAuthor(string name, string post, string comment)
        {
            throw new NotImplementedException();
        }

        #region IPostService Members


        public Comment AddComment(string name, string post, Comment comment)
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}
